/**
 * @file cpu.h
 * Header file for cpu.c
 */

#ifndef CPU_H
#define CPU_H

typedef unsigned int UINT;

/** 
 * @brief Registers 
 * 
 * Structure containing all registers of 6502
 */
typedef struct {
	UINT PC;			/**< Program counter */
	unsigned char X;	/**< Index register X */	
	unsigned char Y;	/**< Index register Y */
	unsigned char A;	/**< Accumulator */
	unsigned char P;	/**< Status register */
	UINT S;				/**< Stack pointer */
} Regs;


unsigned char (*memgetb) (UINT adr);
void (*memsetb) (UINT adr, unsigned char byte);

void Reset();
void Irq();
void Nmi();
UINT InstrStep();
Regs* GetRegs();
void SetRegs(Regs r);

#endif //#ifndef CPU_H