/**
 * @file dllkit.c
 * Implements functions from @a dllkit.h.
 * Library for creating emu6502 plugins.
 */

#include "dllkit.h"

BOOL CreateMsgList(MSGLIST* MsgList, int MessageCount)
{
	if (MessageCount == 0) {
		return FALSE;
	}
	*MsgList = calloc(MessageCount + 1, sizeof(UINT));
	if (*MsgList == NULL) {
		return FALSE;
	}
	(*MsgList)[0] = ENDOFMSGLIST;
	return TRUE;
}

void FreeMsgList(MSGLIST MsgList)
{
	free(MsgList);
}

void AddMessage(MSGLIST MsgList, UINT Message)
{
	int i;
	if (MsgList == NULL || Message == ENDOFMSGLIST) {
		return;
	}
	for (i = 0; MsgList[i] != ENDOFMSGLIST; i++)
		;
	MsgList[i] = Message;
	MsgList[i+1] = ENDOFMSGLIST;
}
